#ifndef _DB_HELPER_H_
#define _DB_HELPER_H_

#include <db_cxx.h>

typedef struct _DB_LOCK {
    DbEnv* dbenv;
    DB_LOCK lock;
} _DB_LOCK;

extern "C" {
int _dbenv_create(DbEnv** dbenvpp, u_int32_t flags);
void _dbenv_delete(DbEnv* dbenvp);
int _dbenv_get_lk_max_lockers(DbEnv* dbenvp, u_int32_t *lk_maxp);
int _dbenv_set_lk_max_lockers(DbEnv* dbenvp, u_int32_t max);
int _dbenv_get_lk_max_locks(DbEnv* dbenvp, u_int32_t *lk_maxp);
int _dbenv_set_lk_max_locks(DbEnv* dbenvp, u_int32_t max);
int _dbenv_get_lk_max_objects(DbEnv* dbenvp, u_int32_t *lk_maxp);
int _dbenv_set_lk_max_objects(DbEnv* dbenvp, u_int32_t max);
int _dbenv_get_tx_max(DbEnv* dbenvp, u_int32_t *lk_maxp);
int _dbenv_set_tx_max(DbEnv* dbenvp, u_int32_t max);
int _dbenv_get_cachesize(DbEnv* dbenvp, u_int32_t *gbytesp, u_int32_t *bytesp, int *ncachep);
int _dbenv_set_cachesize(DbEnv* dbenvp, u_int32_t gbytes, u_int32_t bytes, int ncache);
int _dbenv_get_lg_regionmax(DbEnv* dbenvp, u_int32_t *lk_maxp);
int _dbenv_set_lg_regionmax(DbEnv* dbenvp, u_int32_t max);
int _dbenv_open(DbEnv* dbenvp, char *db_home, u_int32_t flags, int mode);
int _db_create(DB*** dbpp, DbEnv* dbenvp, u_int32_t flags);
void _db_delete(DB** db);
int _db_set_pagesize(DB** dbp, u_int32_t pagesize);
int _db_open(DB** dbp, DbTxn** txnp, const char* file, const char* database,
    int type, u_int32_t flags, int mode);
int _dbenv_txn_begin(DbEnv* dbenvp, DbTxn** parent, DbTxn*** txnpp, u_int32_t flags);
int _dbenv_txn_checkpoint(DbEnv* dbenvp, u_int32_t kbyte, u_int32_t min, u_int32_t flags);
int _dbtxn_abort(DbTxn** dbtxnp);
int _dbtxn_commit(DbTxn** dbtxnp, u_int32_t flags);
void _dbtxn_delete(DbTxn** dbtxnp);
u_int32_t _dbtxn_id(DbTxn** dbtxnp);
void _dblock_delete(_DB_LOCK* dblock);
int _dbenv_lock_get(DbEnv* dbenvp, u_int32_t lockerID, u_int32_t flags,
    const char* object, u_int32_t object_len, u_int32_t lockmode, _DB_LOCK** dblock);
int _dbenv_lock_put(_DB_LOCK* dblock);
void _deleteString(char* str);
void _freeString(char* str);
int _db_get(DB** dbp, DbTxn** dbtxnp, const char* key, u_int32_t key_len, char** value, u_int32_t* value_len, u_int32_t flags);
int _db_put(DB** dbp, DbTxn** dbtxnp, const char* key, u_int32_t key_len, const char* value, u_int32_t value_len, u_int32_t flags);
int _db_del(DB** dbp, DbTxn** dbtxnp, const char* key, u_int32_t key_len, u_int32_t flags);
int _db_close(DB** dbp, u_int32_t flags);
int _dbenv_close(DbEnv* dbEnv, u_int32_t flags);
int _dbenv_set_lk_detect(DbEnv* dbEnv, u_int32_t flag);
}

#endif

